diff --git a/src/main/java/net/minecraft/client/Minecraft.java b/src/main/java/net/minecraft/client/Minecraft.java
index 66e343920..ed22306f2 100644
--- a/src/main/java/net/minecraft/client/Minecraft.java
+++ b/src/main/java/net/minecraft/client/Minecraft.java
@@ -29,6 +29,36 @@ import net.minecraft.core.achievement.Achievements;
 import net.minecraft.core.block.BlockLeavesBase;
 import net.minecraft.core.block.entity.TileEntityDispatcher;
 import net.minecraft.core.entity.EntityDispatcher;
+import net.minecraft.core.net.command.CommandManager;
+import net.minecraft.core.net.command.commands.CommandAchievement;
+import net.minecraft.core.net.command.commands.CommandBiome;
+import net.minecraft.core.net.command.commands.CommandChunk;
+import net.minecraft.core.net.command.commands.CommandClear;
+import net.minecraft.core.net.command.commands.CommandClone;
+import net.minecraft.core.net.command.commands.CommandDamage;
+import net.minecraft.core.net.command.commands.CommandFill;
+import net.minecraft.core.net.command.commands.CommandGameMode;
+import net.minecraft.core.net.command.commands.CommandGameRule;
+import net.minecraft.core.net.command.commands.CommandGive;
+import net.minecraft.core.net.command.commands.CommandHeal;
+import net.minecraft.core.net.command.commands.CommandHelp;
+import net.minecraft.core.net.command.commands.CommandKill;
+import net.minecraft.core.net.command.commands.CommandMessage;
+import net.minecraft.core.net.command.commands.CommandMobSpawning;
+import net.minecraft.core.net.command.commands.CommandPlace;
+import net.minecraft.core.net.command.commands.CommandPlaySound;
+import net.minecraft.core.net.command.commands.CommandSay;
+import net.minecraft.core.net.command.commands.CommandSeed;
+import net.minecraft.core.net.command.commands.CommandSetBlock;
+import net.minecraft.core.net.command.commands.CommandSetSpawn;
+import net.minecraft.core.net.command.commands.CommandSpawn;
+import net.minecraft.core.net.command.commands.CommandSpawnParticle;
+import net.minecraft.core.net.command.commands.CommandSummon;
+import net.minecraft.core.net.command.commands.CommandTeleport;
+import net.minecraft.core.net.command.commands.CommandTellRaw;
+import net.minecraft.core.net.command.commands.CommandTestFor;
+import net.minecraft.core.net.command.commands.CommandTime;
+import net.minecraft.core.net.command.commands.CommandWeather;
 import net.minecraft.core.net.command.util.CommandHelper;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.LoggedPrintStream;
@@ -397,6 +427,7 @@ public class Minecraft
         EntityDispatcher.init();
         TileEntityDispatcher.init();
         CommandHelper.init();
+        initCommands();
 
 		gameSettings = new GameSettings(this, mcDataDir);
 
@@ -598,6 +629,38 @@ public class Minecraft
         }
         gameWindow.updateWindowState();
     }
+
+    public void initCommands() {
+        CommandManager.registerCommand(new CommandAchievement());
+        CommandManager.registerCommand(new CommandClear());
+        CommandManager.registerCommand(new CommandKill());
+        CommandManager.registerCommand(new CommandSeed());
+        CommandManager.registerCommand(new CommandSetBlock());
+        CommandManager.registerCommand(new CommandSummon());
+        CommandManager.registerCommand(new CommandTeleport());
+        CommandManager.registerCommand(new CommandMessage());
+        CommandManager.registerCommand(new CommandSetSpawn());
+        CommandManager.registerCommand(new CommandTime());
+        CommandManager.registerCommand(new CommandGameMode());
+        CommandManager.registerCommand(new CommandWeather());
+        CommandManager.registerCommand(new CommandSpawn());
+        CommandManager.registerCommand(new CommandPlace());
+        CommandManager.registerCommand(new CommandHelp());
+        CommandManager.registerCommand(new CommandChunk());
+        CommandManager.registerCommand(new CommandGive());
+        CommandManager.registerCommand(new CommandGameRule());
+        CommandManager.registerCommand(new CommandFill());
+        CommandManager.registerCommand(new CommandClone());
+        CommandManager.registerCommand(new CommandBiome());
+        CommandManager.registerCommand(new CommandSay());
+        CommandManager.registerCommand(new CommandTellRaw());
+        CommandManager.registerCommand(new CommandTestFor());
+        CommandManager.registerCommand(new CommandDamage());
+        CommandManager.registerCommand(new CommandHeal());
+        CommandManager.registerCommand(new CommandMobSpawning());
+        CommandManager.registerCommand(new CommandPlaySound());
+        CommandManager.registerCommand(new CommandSpawnParticle());
+    }
     
     private void printWrongJavaVersionInfo() {
     	String javaVersion = System.getProperty("java.version");
diff --git a/src/main/java/net/minecraft/client/entity/player/PlayerLocal.java b/src/main/java/net/minecraft/client/entity/player/PlayerLocal.java
index 9e1fa0388..5f8093ad6 100644
--- a/src/main/java/net/minecraft/client/entity/player/PlayerLocal.java
+++ b/src/main/java/net/minecraft/client/entity/player/PlayerLocal.java
@@ -37,6 +37,7 @@ import net.minecraft.core.block.entity.TileEntityTrommel;
 import net.minecraft.core.data.gamerule.GameRules;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.entity.vehicle.EntityBoat;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.net.command.TextFormatting;
 import net.minecraft.client.net.command.ClientCommandSource;
@@ -515,4 +516,15 @@ public class PlayerLocal extends Player
 		mc.hudIngame.heldItemTooltipElement.setString(message);
 	}
 
+    @Override
+    public boolean lerpVehicleMotion() {
+        return false;
+    }
+
+    @Override
+    public void handleSpecialVehicleControl() {
+        if (vehicle instanceof EntityBoat) {
+            ((EntityBoat) vehicle).controlBoat(-input.moveForward, -input.moveStrafe);
+        }
+    }
 }
diff --git a/src/main/java/net/minecraft/client/entity/player/PlayerLocalMultiplayer.java b/src/main/java/net/minecraft/client/entity/player/PlayerLocalMultiplayer.java
index 4eb0cad3a..cc674e2b1 100644
--- a/src/main/java/net/minecraft/client/entity/player/PlayerLocalMultiplayer.java
+++ b/src/main/java/net/minecraft/client/entity/player/PlayerLocalMultiplayer.java
@@ -7,6 +7,8 @@ import net.minecraft.core.achievement.stat.Stat;
 import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityItem;
+import net.minecraft.core.entity.vehicle.EntityBoat;
+import net.minecraft.core.net.packet.BoatControlPacket;
 import net.minecraft.core.net.packet.ChatPacket;
 import net.minecraft.core.net.packet.UpdatePlayerStatePacket;
 import net.minecraft.core.net.packet.MovePlayerPacket;
@@ -274,4 +276,11 @@ public class PlayerLocalMultiplayer extends PlayerLocal
     public void pickBlock(int x, int y, int z) {
     	sendQueue.addToSendQueue(new PlayerActionPacket(PlayerActionPacket.ACTION_PICK_BLOCK, x, y, z, Side.NONE, 0.0, 0.0));
     }
+
+    @Override
+    public void sendSpecialVehiclePacket() {
+        if (vehicle instanceof EntityBoat) {
+            sendQueue.addToSendQueue(new BoatControlPacket((EntityBoat) vehicle));
+        }
+    }
 }
diff --git a/src/main/java/net/minecraft/client/net/command/ClientCommandSource.java b/src/main/java/net/minecraft/client/net/command/ClientCommandSource.java
index 424218f0e..6e3f2e650 100644
--- a/src/main/java/net/minecraft/client/net/command/ClientCommandSource.java
+++ b/src/main/java/net/minecraft/client/net/command/ClientCommandSource.java
@@ -5,6 +5,7 @@ import net.minecraft.client.world.WorldClient;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.net.command.CommandSource;
 import net.minecraft.core.net.command.helpers.EntitySelector;
+import net.minecraft.core.net.packet.Packet;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.Dimension;
@@ -14,6 +15,7 @@ import org.jetbrains.annotations.NotNull;
 import java.util.ArrayList;
 import java.util.Collection;
 import java.util.List;
+import java.util.function.Supplier;
 
 public class ClientCommandSource implements CommandSource {
     private final Minecraft mc;
@@ -93,6 +95,11 @@ public class ClientCommandSource implements CommandSource {
         this.mc.thePlayer.sendChatMessage(message);
     }
 
+    @Override
+    public void sendPacketToAllPlayers(Supplier<Packet> packetSupplier) {
+
+    }
+
     @Override
     public World getWorld() {
         return this.mc.currentWorld;
diff --git a/src/main/java/net/minecraft/client/net/handler/PacketHandlerClient.java b/src/main/java/net/minecraft/client/net/handler/PacketHandlerClient.java
index e731d560b..bd0ddce0e 100644
--- a/src/main/java/net/minecraft/client/net/handler/PacketHandlerClient.java
+++ b/src/main/java/net/minecraft/client/net/handler/PacketHandlerClient.java
@@ -38,6 +38,7 @@ import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.EntityPainting;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.entity.projectile.Projectile;
+import net.minecraft.core.entity.vehicle.EntityBoat;
 import net.minecraft.core.enums.ArtType;
 import net.minecraft.core.item.ItemMap;
 import net.minecraft.core.item.ItemStack;
@@ -589,6 +590,15 @@ public class PacketHandlerClient extends PacketHandler
         }
     }
 
+    @Override
+    public void handleBoatControl(BoatControlPacket boatControlPacket)
+    {
+        Entity e = worldClientMP.getEntityFromId(boatControlPacket.entityId);
+        if (e instanceof EntityBoat) {
+            ((EntityBoat)e).handleControlDirect(boatControlPacket.targetXD, boatControlPacket.targetZD, boatControlPacket.targetYRot);
+        }
+    }
+
     @Override
     public void handleSleep(SleepPacket sleepPacket)
     {
diff --git a/src/main/java/net/minecraft/core/entity/Entity.java b/src/main/java/net/minecraft/core/entity/Entity.java
index 9a4ebc534..2f436b111 100644
--- a/src/main/java/net/minecraft/core/entity/Entity.java
+++ b/src/main/java/net/minecraft/core/entity/Entity.java
@@ -43,8 +43,8 @@ public abstract class Entity
     public int id = entityCounter++;
     public double viewScale = 1.0D;
     public boolean blocksBuilding = false;
-    public Entity passenger;
-    public IVehicle vehicle;
+    public @Nullable Entity passenger;
+    public @Nullable IVehicle vehicle;
     public World world;
     public double xo;
     public double yo;
@@ -1502,6 +1502,23 @@ public abstract class Entity
         return (float) MathHelper.deltaAngle(xRot, xRotO);
     }
 
+    // TODO at some point create a better more generalized method of controlling vehicles
+    public boolean lerpVehicleMotion() {
+        return true;
+    }
+
+    public void handleSpecialVehicleControl() {
+
+    }
+
+    public void sendSpecialVehiclePacket() {
+
+    }
+
+    public boolean deferVehicleBehavior() {
+        return false;
+    }
+
     public static String getNameFromEntity(Entity entity, boolean useNickname){
         I18n translator = I18n.getInstance();
         if (entity instanceof Mob && useNickname){
diff --git a/src/main/java/net/minecraft/core/entity/player/Player.java b/src/main/java/net/minecraft/core/entity/player/Player.java
index f49e0c959..d9638f7a9 100644
--- a/src/main/java/net/minecraft/core/entity/player/Player.java
+++ b/src/main/java/net/minecraft/core/entity/player/Player.java
@@ -69,7 +69,6 @@ import net.minecraft.core.world.World;
 import net.minecraft.core.world.chunk.ChunkCoordinates;
 import net.minecraft.core.world.chunk.provider.IChunkProvider;
 import net.minecraft.core.world.weather.Weathers;
-import net.minecraft.server.entity.player.PlayerServer;
 import org.jetbrains.annotations.Nullable;
 
 import java.util.ArrayList;
@@ -494,9 +493,9 @@ public abstract class Player extends Mob
         }
         if (entityKilledBy instanceof ProjectileArrowGolden)
         {
-            if (((ProjectileArrowGolden) entityKilledBy).owner instanceof PlayerServer)
+            if (((ProjectileArrowGolden) entityKilledBy).owner instanceof Player)
             {
-                if (((PlayerServer) ((ProjectileArrowGolden) entityKilledBy).owner).uuid.equals(uuid))
+                if (((Player) ((ProjectileArrowGolden) entityKilledBy).owner).uuid.equals(uuid))
                 {
                     return getDisplayName() + deathMsgColor + " got gold in their eye.";
                 }
@@ -514,9 +513,9 @@ public abstract class Player extends Mob
             {
                 return getDisplayName() + deathMsgColor + " was a victim of aimbot.";
             }
-            else if (((ProjectileArrow) entityKilledBy).owner instanceof PlayerServer)
+            else if (((ProjectileArrow) entityKilledBy).owner instanceof Player)
             {
-                if (((PlayerServer) ((ProjectileArrow) entityKilledBy).owner).uuid.equals(uuid))
+                if (((Player) ((ProjectileArrow) entityKilledBy).owner).uuid.equals(uuid))
                 {
                     return getDisplayName() + deathMsgColor + " lost a game of Russian roulette.";
                 }
@@ -530,9 +529,9 @@ public abstract class Player extends Mob
         }
         if (entityKilledBy instanceof ProjectileCannonball)
         {
-            if (((ProjectileCannonball) entityKilledBy).owner instanceof PlayerServer)
+            if (((ProjectileCannonball) entityKilledBy).owner instanceof Player)
             {
-                if (((PlayerServer) ((ProjectileCannonball) entityKilledBy).owner).uuid.equals(uuid))
+                if (((Player) ((ProjectileCannonball) entityKilledBy).owner).uuid.equals(uuid))
                 {
                     return getDisplayName() + deathMsgColor + " jumped too high.";
                 }
@@ -560,9 +559,9 @@ public abstract class Player extends Mob
         {
             return getDisplayName() + deathMsgColor + " was killed by Popbob.";
         }
-        if (entityKilledBy instanceof PlayerServer)
+        if (entityKilledBy instanceof Player)
         {
-            return getDisplayName() + deathMsgColor + " was backstabbed by " + ((PlayerServer) entityKilledBy).getDisplayName() + deathMsgColor + ".";
+            return getDisplayName() + deathMsgColor + " was backstabbed by " + ((Player) entityKilledBy).getDisplayName() + deathMsgColor + ".";
         }
         if (entityKilledBy instanceof MobPig)
         {
diff --git a/src/main/java/net/minecraft/core/entity/vehicle/EntityBoat.java b/src/main/java/net/minecraft/core/entity/vehicle/EntityBoat.java
index 041ef1fde..31e44a513 100644
--- a/src/main/java/net/minecraft/core/entity/vehicle/EntityBoat.java
+++ b/src/main/java/net/minecraft/core/entity/vehicle/EntityBoat.java
@@ -1,8 +1,6 @@
 package net.minecraft.core.entity.vehicle;
 
 import com.mojang.nbt.CompoundTag;
-import net.minecraft.client.entity.player.PlayerLocalMultiplayer;
-import net.minecraft.client.entity.player.PlayerLocal;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntityFlag;
@@ -12,7 +10,6 @@ import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.net.packet.BoatControlPacket;
 import net.minecraft.core.player.gamemode.Gamemode;
 import net.minecraft.core.util.helper.BlockParticleHelper;
 import net.minecraft.core.util.helper.DamageType;
@@ -20,7 +17,6 @@ import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
-import net.minecraft.server.entity.player.PlayerServer;
 
 import java.util.List;
 
@@ -207,7 +203,7 @@ public class EntityBoat extends Entity
         boatPitch = xRot;
         lerpTicks = i;
         // Don't interpolate velocity from server when controlling the boat
-        if (passenger instanceof PlayerLocal) return;
+        if (passenger != null && !passenger.lerpVehicleMotion()) return;
         lerpYRot = yRot;
         xd = velocityX;
         yd = velocityY;
@@ -218,7 +214,7 @@ public class EntityBoat extends Entity
 	public void lerpMotion(double xd, double yd, double zd)
     {
         // Don't interpolate velocity from server when controlling the boat
-        if (passenger instanceof PlayerLocal) return;
+        if (passenger != null && !passenger.lerpVehicleMotion()) return;
         velocityX = this.xd = xd;
         velocityY = this.yd = yd;
         velocityZ = this.zd = zd;
@@ -260,7 +256,7 @@ public class EntityBoat extends Entity
                 double lerpY = y + (this.lerpY - y) / (double) lerpTicks;
                 double lerpZ = z + (this.lerpZ - z) / (double) lerpTicks;
                 xRot += (boatPitch - xRot) / lerpTicks;
-                if (!(passenger instanceof PlayerLocalMultiplayer)){
+                if (passenger == null || passenger.lerpVehicleMotion()){
                     float lerpYRot;
                     lerpYRot = MathHelper.normalizeRotation(this.lerpYRot - yRot);
                     yRot += lerpYRot / lerpTicks;
@@ -328,7 +324,7 @@ public class EntityBoat extends Entity
 
         }
 
-        if (!(passenger instanceof PlayerServer)){
+        if (passenger == null || !passenger.deferVehicleBehavior()){
             xd *= 0.99D;
             yd *= 0.95D;
             zd *= 0.99D;
@@ -383,10 +379,8 @@ public class EntityBoat extends Entity
         double xdOff;
         double zdOff;
         currentBoatSpeed = Math.hypot(xd, zd);
-        if(passenger != null && passenger instanceof PlayerLocal)
-        {
-            PlayerLocal sp = (PlayerLocal) passenger;
-            controlBoat(-sp.input.moveForward, -sp.input.moveStrafe);
+        if(passenger != null) {
+            passenger.handleSpecialVehicleControl();
         }
         yRot += pendingYRot;
         pendingYRot = 0;
@@ -406,8 +400,8 @@ public class EntityBoat extends Entity
         xd += xdOff;
         zd += zdOff;
 
-        if (passenger instanceof PlayerLocalMultiplayer){
-            ((PlayerLocalMultiplayer)passenger).sendQueue.addToSendQueue(new BoatControlPacket(this));
+        if(passenger != null) {
+            passenger.sendSpecialVehiclePacket();
         }
 
         // Cap max speed properly
diff --git a/src/main/java/net/minecraft/core/net/command/CommandManager.java b/src/main/java/net/minecraft/core/net/command/CommandManager.java
index 2047e2745..9b6699b7d 100644
--- a/src/main/java/net/minecraft/core/net/command/CommandManager.java
+++ b/src/main/java/net/minecraft/core/net/command/CommandManager.java
@@ -3,8 +3,6 @@ package net.minecraft.core.net.command;
 import com.mojang.brigadier.CommandDispatcher;
 import com.mojang.brigadier.ParseResults;
 import com.mojang.brigadier.exceptions.CommandSyntaxException;
-import net.minecraft.core.net.command.commands.*;
-import net.minecraft.server.net.command.commands.*;
 import org.jetbrains.annotations.Nullable;
 
 import java.util.ArrayList;
@@ -23,53 +21,7 @@ public class CommandManager {
     private static final Collection<CommandRegistry> externalServerCommands = new ArrayList<>();
 
     public void init() {
-        CommandAchievement.register(DISPATCHER);
-        CommandClear.register(DISPATCHER);
-        CommandKill.register(DISPATCHER);
-        CommandSeed.register(DISPATCHER);
-        CommandSetBlock.register(DISPATCHER);
-        CommandSummon.register(DISPATCHER);
-        CommandTeleport.register(DISPATCHER);
-        CommandMessage.register(DISPATCHER);
-        CommandSetSpawn.register(DISPATCHER);
-        CommandTime.register(DISPATCHER);
-        CommandGameMode.register(DISPATCHER);
-        CommandWeather.register(DISPATCHER);
-        CommandSpawn.register(DISPATCHER);
-        CommandPlace.register(DISPATCHER);
-        CommandHelp.register(DISPATCHER);
-        CommandChunk.register(DISPATCHER);
-        CommandGive.register(DISPATCHER);
-        CommandGameRule.register(DISPATCHER);
-        CommandFill.register(DISPATCHER);
-        CommandClone.register(DISPATCHER);
-        CommandBiome.register(DISPATCHER);
-        CommandSay.register(DISPATCHER);
-        CommandTellRaw.register(DISPATCHER);
-        CommandTestFor.register(DISPATCHER);
-        CommandDamage.register(DISPATCHER);
-        CommandHeal.register(DISPATCHER);
-        CommandMobSpawning.register(DISPATCHER);
-        CommandPlaySound.register(DISPATCHER);
-        CommandSpawnParticle.register(DISPATCHER);
-
         if (this.isServer) {
-            CommandStop.register(DISPATCHER);
-            CommandOp.register(DISPATCHER);
-            CommandDeop.register(DISPATCHER);
-            CommandList.register(DISPATCHER);
-            CommandDifficulty.register(DISPATCHER);
-            CommandColor.register(DISPATCHER);
-            CommandNickname.register(DISPATCHER);
-            CommandWhoIs.register(DISPATCHER);
-            CommandScore.register(DISPATCHER);
-            CommandMe.register(DISPATCHER);
-            CommandEmotes.register(DISPATCHER);
-            CommandBan.register(DISPATCHER);
-            CommandUnban.register(DISPATCHER);
-            CommandKick.register(DISPATCHER);
-            CommandWhitelist.register(DISPATCHER);
-            CommandSave.register(DISPATCHER);
             for (CommandRegistry registry : externalServerCommands) {
                 registry.register(DISPATCHER);
             }
diff --git a/src/main/java/net/minecraft/core/net/command/CommandSource.java b/src/main/java/net/minecraft/core/net/command/CommandSource.java
index 475eb99fb..32222cbcd 100644
--- a/src/main/java/net/minecraft/core/net/command/CommandSource.java
+++ b/src/main/java/net/minecraft/core/net/command/CommandSource.java
@@ -2,12 +2,14 @@ package net.minecraft.core.net.command;
 
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.lang.I18n;
+import net.minecraft.core.net.packet.Packet;
 import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.Nullable;
 
 import java.util.Collection;
 import java.util.Collections;
+import java.util.function.Supplier;
 
 public interface CommandSource {
     Collection<String> getPlayerNames();
@@ -47,6 +49,8 @@ public interface CommandSource {
 
     void sendMessageToAllPlayers(String message);
 
+    void sendPacketToAllPlayers(Supplier<Packet> packetSupplier);
+
     World getWorld();
 
     World getWorld(int dimension);
diff --git a/src/main/java/net/minecraft/core/net/command/commands/CommandAchievement.java b/src/main/java/net/minecraft/core/net/command/commands/CommandAchievement.java
index 2da4734d6..4d390f75a 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/CommandAchievement.java
+++ b/src/main/java/net/minecraft/core/net/command/commands/CommandAchievement.java
@@ -11,6 +11,7 @@ import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.lang.I18n;
+import net.minecraft.core.net.command.CommandManager;
 import net.minecraft.core.net.command.CommandSource;
 import net.minecraft.core.net.command.arguments.ArgumentTypeAchievement;
 import net.minecraft.core.net.command.arguments.ArgumentTypeEntity;
@@ -19,10 +20,10 @@ import net.minecraft.core.net.command.helpers.EntitySelector;
 import java.util.ArrayList;
 import java.util.List;
 
-public class CommandAchievement {
+public class CommandAchievement implements CommandManager.CommandRegistry {
     private static final SimpleCommandExceptionType PLAYER_ALREADY_HAS_ACHIEVEMENT = new SimpleCommandExceptionType(() -> I18n.getInstance().translateKey("command.commands.achievement.grant.exception_already_has_achievement"));
 
-    public static void register(CommandDispatcher<CommandSource> dispatcher) {
+    public void register(CommandDispatcher<CommandSource> dispatcher) {
         dispatcher.register(((LiteralArgumentBuilder.<CommandSource>literal("achievement"))
             .requires(CommandSource::hasAdmin)
             .then((LiteralArgumentBuilder.<CommandSource>literal("grant"))
diff --git a/src/main/java/net/minecraft/core/net/command/commands/CommandBiome.java b/src/main/java/net/minecraft/core/net/command/commands/CommandBiome.java
index 1d4f726ad..724ee22fc 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/CommandBiome.java
+++ b/src/main/java/net/minecraft/core/net/command/commands/CommandBiome.java
@@ -7,6 +7,7 @@ import com.mojang.brigadier.builder.RequiredArgumentBuilder;
 import com.mojang.brigadier.exceptions.DynamicCommandExceptionType;
 import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.lang.I18n;
+import net.minecraft.core.net.command.CommandManager;
 import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.net.command.CommandSource;
@@ -15,10 +16,10 @@ import net.minecraft.core.net.command.arguments.ArgumentTypeIntegerCoordinates;
 import net.minecraft.core.net.command.helpers.Coordinates2D;
 import net.minecraft.core.net.command.helpers.IntegerCoordinates;
 
-public class CommandBiome {
+public class CommandBiome implements CommandManager.CommandRegistry {
     private static final DynamicCommandExceptionType FAILURE = new DynamicCommandExceptionType(arg -> () -> I18n.getInstance().translateKeyAndFormat("command.commands.biome.locate.exception_failure", arg));
 
-    public static void register(CommandDispatcher<CommandSource> dispatcher) {
+    public void register(CommandDispatcher<CommandSource> dispatcher) {
         dispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("biome")
                 .requires(CommandSource::hasAdmin)
                 .then(LiteralArgumentBuilder.<CommandSource>literal("get")
diff --git a/src/main/java/net/minecraft/core/net/command/commands/CommandChunk.java b/src/main/java/net/minecraft/core/net/command/commands/CommandChunk.java
index ba6971aef..c71febbb6 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/CommandChunk.java
+++ b/src/main/java/net/minecraft/core/net/command/commands/CommandChunk.java
@@ -4,14 +4,15 @@ import com.mojang.brigadier.Command;
 import com.mojang.brigadier.CommandDispatcher;
 import com.mojang.brigadier.builder.LiteralArgumentBuilder;
 import com.mojang.brigadier.builder.RequiredArgumentBuilder;
+import net.minecraft.core.net.command.CommandManager;
 import net.minecraft.core.net.command.CommandSource;
 import net.minecraft.core.net.command.arguments.ArgumentTypeChunkCoordinates;
 import net.minecraft.core.net.command.helpers.Coordinates2D;
 import net.minecraft.core.world.LevelListener;
 import net.minecraft.core.world.World;
 
-public class CommandChunk {
-    public static void register(CommandDispatcher<CommandSource> dispatcher) {
+public class CommandChunk implements CommandManager.CommandRegistry {
+    public void register(CommandDispatcher<CommandSource> dispatcher) {
         dispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("chunk")
             .requires(CommandSource::hasAdmin)
             .then(LiteralArgumentBuilder.<CommandSource>literal("reset")
diff --git a/src/main/java/net/minecraft/core/net/command/commands/CommandClear.java b/src/main/java/net/minecraft/core/net/command/commands/CommandClear.java
index 8c22343ce..1ef4da227 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/CommandClear.java
+++ b/src/main/java/net/minecraft/core/net/command/commands/CommandClear.java
@@ -11,6 +11,7 @@ import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.lang.I18n;
+import net.minecraft.core.net.command.CommandManager;
 import net.minecraft.core.net.command.CommandSource;
 import net.minecraft.core.net.command.arguments.ArgumentTypeEntity;
 import net.minecraft.core.net.command.arguments.ArgumentTypeItemStack;
@@ -23,12 +24,12 @@ import java.util.Collections;
 import java.util.List;
 import java.util.Map;
 
-public class CommandClear {
+public class CommandClear implements CommandManager.CommandRegistry {
     private static final Logger LOGGER = LogUtils.getLogger();
 
     private static final SimpleCommandExceptionType FAILURE = new SimpleCommandExceptionType(() -> I18n.getInstance().translateKey("command.commands.clear.exception_failure"));
 
-    public static void register(CommandDispatcher<CommandSource> dispatcher) {
+    public void register(CommandDispatcher<CommandSource> dispatcher) {
         dispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("clear")
             .requires(CommandSource::hasAdmin)
             .executes(c -> {
diff --git a/src/main/java/net/minecraft/core/net/command/commands/CommandClone.java b/src/main/java/net/minecraft/core/net/command/commands/CommandClone.java
index 8c3138a4e..b46e3ea43 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/CommandClone.java
+++ b/src/main/java/net/minecraft/core/net/command/commands/CommandClone.java
@@ -10,6 +10,7 @@ import com.mojang.brigadier.exceptions.SimpleCommandExceptionType;
 import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.lang.I18n;
+import net.minecraft.core.net.command.CommandManager;
 import net.minecraft.core.net.command.util.CommandHelper;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.util.phys.Vec3;
@@ -28,13 +29,13 @@ import org.jetbrains.annotations.Nullable;
 import java.util.HashMap;
 import java.util.Map;
 
-public class CommandClone {
+public class CommandClone implements CommandManager.CommandRegistry {
     private static final SimpleCommandExceptionType INSIDE_CLONED_AREA = new SimpleCommandExceptionType(() -> I18n.getInstance().translateKey("command.commands.clone.exception_inside_cloned_area"));
     private static final SimpleCommandExceptionType DESTINATION_NOT_LOADED = new SimpleCommandExceptionType(() -> I18n.getInstance().translateKey("command.commands.clone.exception_destination_not_loaded"));
     private static final SimpleCommandExceptionType SOURCE_NOT_LOADED = new SimpleCommandExceptionType(() -> I18n.getInstance().translateKey("command.commands.clone.exception_source_not_loaded"));
     private static final SimpleCommandExceptionType NOWHERE_LOADED = new SimpleCommandExceptionType(() -> I18n.getInstance().translateKey("command.commands.clone.exception_nowhere_loaded"));
 
-    public static void register(CommandDispatcher<CommandSource> commandDispatcher) {
+    public void register(CommandDispatcher<CommandSource> commandDispatcher) {
         commandDispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("clone")
                 .requires(CommandSource::hasAdmin)
                 .then(beginEndDestinationAndModeSuffix(c -> {
